﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.8
@EndOfDesignText@
Sub Class_Globals
	
	Private xui As XUI
	Type MenuHeader(mnuName As String, Index As Int,BackColor As Int, Tag As String, Icon As Char)
	Type MenuItems(Index As Int, Items() As String, Icons() As Char, Tags() As String, BackColor() As Int, LayOut() As String)
	
	Public MainMenus As List
	Public SubMenus As List
	Public SecurityCode As String
	Public LeftBC As Int
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	MainMenus.Initialize
	SubMenus.Initialize
	If SecurityCode="" Then SecurityCode="AA01A02A03"
	setMenus
	
End Sub

Public Sub setMenus

	setHeaderMenu
	setSubMenus
End Sub

Private Sub setHeaderMenu
		
	Dim mh As MenuHeader
	mh.Initialize
	mh.mnuName="Demo vsListBox controls"
	
	mh.Index =  1
	mh.BackColor =  0xFF00A1FF
	mh.Tag =  "A"
	mh.Icon =  Chr(0xF015)
	MainMenus.Add(mh)
	Dim mh As MenuHeader
	mh.Initialize
	
'	mh.mnuName =  "Demo vsListBox controls"
'	mh.Index =  2
'	mh.BackColor =  0xFF00A1FF
'	mh.Tag =  "B"
'	mh.Icon =  Chr(0xF044) 
'	MainMenus.Add(mh)
'	Dim mh As MenuHeader
'	mh.Initialize
	
'	mh.mnuName =  "Demo Linked to other controls"
'	mh.Index =  3
'	mh.BackColor =  0xFF00A1FF
'	mh.Tag =  "C"
'	mh.Icon =  Chr(0xF1EC)
'	MainMenus.Add(mh)
	

	
End Sub

Private Sub setSubMenus
	Dim mi As MenuItems
	mi.Initialize

	Dim SM() As String
	Dim Icons() As Char
	Dim Tags() As String
	Dim BC() As Int
	'Home Menu
	SM=Array As  String("Unlinked vsListBox","Linked vsListBox","Exit")
	Icons=Array As Char(Chr(0xF178),Chr(0xF177),Chr(0xF2D4))
	Tags=Array As String("A01","A02","A03")
	
	BC=Array As Int(LeftBC, LeftBC,LeftBC)
	
	mi.Index = 1
	mi.Items = SM
	mi.Icons = Icons
	mi.Tags= Tags
	mi.BackColor =  BC
	SubMenus.Add(mi)
	
'	Dim mi As MenuItems
'	mi.Initialize
'	'UnderWriting
'	SM=Array As  String("Unlinked vsListBox", "Linked vsListBox")
'	Icons=Array As Char(Chr(0xF178),Chr(0xF178))
'	Tags=Array As String("B01","B02")
'	BC=Array As Int(LeftBC,LeftBC)
'	mi.Index = 2
'	mi.Items = SM
'	mi.Icons = Icons
'	mi.Tags= Tags
'	mi.BackColor =  BC
'	SubMenus.Add(mi)
'	
'	Dim mi As MenuItems
'	mi.Initialize
'	'UnderWriting
'	SM=Array As  String("Linked Read Only", "Linked Read/Write", "Linked Load by Code","Linked Multiple Instance")
'	Icons=Array As Char(Chr(0xF178),Chr(0xF178),Chr(0xF178),Chr(0xF178))
'	Tags=Array As String("C01","C02","C03","C04")
'	BC=Array As Int(LeftBC, LeftBC, LeftBC, LeftBC)
'	mi.Index = 3
'	mi.Items = SM
'	mi.Icons = Icons
'	mi.Tags= Tags
'	mi.BackColor =  BC
'	SubMenus.Add(mi)

End Sub

Public Sub LoadMainMenus(ASTab As ASTabMenu) As ASTabMenu
	ASTab.RemoveAllTabs
	For I=0 To MainMenus.Size-1
		Dim mMenu As MenuHeader=MainMenus.Get(I)
		If SecurityCode.Contains(mMenu.Tag) Then
			ASTab.AddTab(xui.Color_White, mMenu.mnuName,ASTab.FontToBitmap(mMenu.Icon,False,30,xui.Color_White),mMenu.Index)
		End If
	Next
	Return ASTab
End Sub

Private Sub SubMenu_Click()
'	Log(Sender)
	Dim bt As Button=Sender
	B4XPages.MainPage.OpenForm(bt)
	Return
	Select bt.Tag
		
		Case "A01"
			B4XPages.MainPage.LoadTab("Login.bjl","Login",bt.Tag.As(String))
		Case "A02"
		
		Case "A03"
			ExitApplication
		Case "B01"
'			If RR.IsInitialized=False Then
'				RR.Initialize
'				B4XPages.AddPage("Request",RR)
'			Else
'								
'			End If
'			Dim RP As RequestRep
'			RP.Initialize
'			B4XPages.AddPage("Request",RP)
'			B4XPages.ShowPage("Request")
'		  B4XPages.MainPage.LoadTab( "RepReq.bjl","Detailed Report","B01")
		Case "B02"
			
	End Select
End Sub

Public Sub ShowSubMenu(Tree As B4XView, ClickedIndex As Int) As B4XView
	
	Tree.As(TreeTableView).Root.Children.Clear
	
	For I=0 To SubMenus.Size-1
		Dim sMenu As MenuItems=SubMenus.Get(I)
		If ClickedIndex+1=sMenu.Index Then
			Dim SM() As String=sMenu.Items
			Dim ICons() As Char=sMenu.Icons
			Dim Tags() As String=sMenu.Tags
			Dim BC() As Int=sMenu.BackColor
			
			For J=0 To SM.Length-1
				If SM(J)="" Then
					Exit
				End If
				If SecurityCode.Contains(Tags(J)) Then
					Dim ti As TreeTableItem
					Dim bt As Button
					bt.Initialize("SubMenu")
					bt.Text=SM(J)
					bt.Tag=Tags(J)
					bt.PrefWidth=Tree.Width
					ti.Initialize("",Array(bt))
					ti.Expanded=True				
					Tree.As(TreeTableView).Root.Children.Add(ti)
				End If
			Next

			Exit
		End If
		
	Next
	
	Return Tree
	
End Sub