﻿B4J=true
Group=Custom View
ModulesStructureVersion=1
Type=StaticCode
Version=9.8
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Public ControlLst As List
'	Public VSListBoxes As Map
	
	Public NoOfControls As Int
	Public Cnt As Control
	Private dbDriver As String
	Private dbURL As String
	Private dbUser As String
	Private dbPassword As String
	Public count As Int
	Public NumOfIndent As Int
	Type dbConnection(dbDriver As String,dbURL As String,dbUser As String,dbPassword As String)
	
End Sub
Public Sub setDBGlobalParameters(Connection As dbConnection)
	dbDriver=Connection.dbDriver
	dbURL=Connection.dbURL
	dbPassword=Connection.dbPassword
	dbUser=Connection.dbUser
'	RefreshLists
End Sub

Public Sub SaveControl(Uniq As Int,cParent As Object, cBase As vsListBox, cDesignerName As String)
	
	If ControlLst.IsInitialized=False Then
		ControlLst.Initialize
	End If
	' Add an event to indicate if a view was removed
	Dim jo As JavaObject=Me
	jo.RunMethod("detectNodeRemoved", Array As Object(cParent))
	ControlLst.Add(Array As Object(Uniq, cDesignerName.ToLowerCase, cParent, cBase))	 
	
End Sub

Sub noderemoved(obj As Object)

Dim N As Node
If obj Is Node Then
	N=obj
Else
	Return
End If
Try
	Log(DateTime.Now)
	For I=ControlLst.Size-1 To 0 Step -1
		Dim Rec() As Object=ControlLst.Get(I)
		Dim cntNum As Int=Rec(0).As(Int)
		Dim cDName As String=Rec(1).As(String)
		' The passed
		If Rec(2) Is Node Then
			Log(I & "is a NODE")
		Else	
			Log(I & "is Not A NODE")			
		End If
		
		If N=Rec(2) Then
			Log(N & "   Removed")	
			ControlLst.RemoveAt(I)
			NoOfControls=NoOfControls-1
		End If
		
	Next
		
Catch
	Log(LastException)
End Try

End Sub
'Using EventName as cDesignerName...Mistake
Public Sub GetLinkedControl(cTargetControlName As String, cParent As Object) As List
	Dim Lst As List
	Lst.Initialize
	
	For I=0 To ControlLst.Size-1
		Dim Rec() As Object=ControlLst.Get(I)
		Dim cntNum As Int=Rec(0).As(Int)
		Dim cDName As String=Rec(1).As(String)
		' The passed
'		If cDName<>cTargetControlName.ToLowerCase Then Continue
		Dim cPar As Object=Rec(2)
		If cPar <> cParent Then Continue 'Same Target Name but not same Parent so its not it
		'If Same Parent and Same Name return the control
		
		Dim Cntrl As vsListBox=Rec(3).As(vsListBox)
		If Cntrl.ControlLink.ToLowerCase=cTargetControlName.ToLowerCase And Cntrl.isLinked Then
			Lst.Add(Cntrl)
		End If
	Next
	Return Lst
End Sub

Public Sub GetControl(cTargetControlName As String, cParent As Object) As vsListBox
	
	For I=0 To ControlLst.Size-1
		Dim Rec() As Object=ControlLst.Get(I)
		Dim cntNum As Int=Rec(0).As(Int)
		Dim cDName As String=Rec(1).As(String)
		' The passed
'		If cDName<>cTargetControlName.ToLowerCase Then Continue
		Dim cPar As Object=Rec(2)
		If cPar <> cParent Then Continue 'Same Target Name but not same Parent so its not it
		'If Same Parent and Same Name return the control
		
		Dim Cntrl As vsListBox=Rec(3).As(vsListBox)
		If cDName.ToLowerCase=cTargetControlName.ToLowerCase Then
			Return Cntrl
		End If
	Next
	Return Null
End Sub

Public Sub getDBGlobalParameters As dbConnection
	Dim db As dbConnection
	db.Initialize
	db.dbDriver=dbDriver
	db.dbPassword=dbPassword
	db.dbURL=dbURL
	db.dbUser=dbUser
	Return db
End Sub

'Public Sub RefreshLists
'	For I=0 To ControlLst.Size-1
'		Dim 
'		Dim vs As vsListBox=ControlLst.Get(I)
'		If vs.DBFromGlobal Then
'			vs.DBDriver=dbDriver
'			vs.DBPassword=dbPassword
'			vs.DBURL=dbURL
'			vs.DBUser=dbUser
'			vs.LoadList
'			VSListBoxes.Put(I,vs)	
'		End If
'	Next
'End Sub




#If Java
import javafx.scene.Node;
import javafx.stage.Window;
import javafx.scene.Scene;
public static boolean isObjectHidden(Object obj) {
    if (obj instanceof Node) {
        Node node = (Node) obj;
        if (node.isVisible()) {
            Scene scene = node.getScene();
            if (scene != null) {
                Window window = scene.getWindow();
                if (window != null) {
                    return !window.isShowing();
                }
            }
        }
    }
    return false;
}

import javafx.beans.value.ChangeListener;
import javafx.beans.value.ObservableValue;
import javafx.scene.Node;

public static void detectNodeRemoved(Object obj) {
    if (obj instanceof Node) {
        Node node = (Node) obj;
	node.sceneProperty().addListener(new ChangeListener<Scene>() {
        @Override
        public void changed(ObservableValue<? extends Scene> observableValue, Scene oldScene, Scene newScene) {
            if (newScene == null) {
				System.out.println(obj);
				System.out.println("Removed");
 				ba.raiseEventFromUI(this, "noderemoved",  node);              
            }
        }
    });
	}
}

 

#End If